  /**************/
 /* FUNKCIJE.C */
/**************/

#include "glava.h"

int V_POP,M,PM;       // velicina populacije, vj.mutacije u promilima
int BR_B,rbr_fje,DIM; // broj bitova - samo kod binarne reprezentacije
                      // redni broj funkcije, dimenzija problema
int br_toc,MAX_GEN;   // broj tocaka test funkcije
                      // broj iteracija
int BR_DRETVI;        // broj dretvi

int Z,P;       // broj zadataka i procesora
float T[MAXZ]; // trajanja zadataka
int *RP;       // kazaljka na tablicu - Relaciju Prethoenja
char fispis[MAXBUF];   // format ispisa

POPULACIJA *p;

void init_sluc(void);
UL sluc(UL n);
double sluc(double d,double g);
int broj(char *);
void ucitaj_parametre(void);
void ucitaj_problem_stg(char *);
void ispisi_long(long);
void vrsta(void);

void init_sluc(){ srand((unsigned)time(NULL)); }
UL sluc(UL n){ return( RND30 %n ); } // slucint[0,n), maxn=2**30-1
double sluc(double d,double g){ return( (double)(d+DO_JEDAN*(g-d)) ); }

int broj(char *s){
   int i;
   for(i=0;i<80;i++) if(s[i] == ' ') break; /* dodji do broja */
   if(i < 80) return(atoi(&s[i+1])); else return(0);
}

void ucitaj_parametre(){
   char *red;
   int i,redak_RP;
   Text_file Parametri(ime_dat,"r+");
   PM = BR_VRSTA = BR_DRETVI = 1;
   redak_RP = 0;
   Z = -1;
   while( (red = Parametri.Uzmi()) != NULL ){
      if( (red[0] == ' ') || (red[0] == '\n') ) continue;
      if( red[0] == 'x' ){ // unos tablice Relacije Prethodjenja
         for(i=0;i<Z;i++) RP[redak_RP*Z+i] = ( red[i] == '1' );
         redak_RP++;
      }
      switch(red[2]){
      case 'I': MAX_GEN = broj(&red[2]); break;
      case 'J': BR_VRSTA = broj(&red[2]); break;
      case 'K': PM = broj(&red[2]); break;
      case 'O': NISP = broj(&red[2]); break;
      case 'P': BR_DRETVI = broj(&red[2]); break;
      case 'S': strcpy(fispis,&red[3]);
                fispis[strlen(&red[3])]=0;
                break;
      case 'V': V_POP = broj(&red[2]); break;
      case 'G': if( RP == NULL ){ 
                   printf("Prvo treba zadati broj zadataka pa tek onda njihova trajanja.\n");
                   exit(1);
                }
                for(i=0;i<Z;i++){
                  T[i] = (float)atof(&red[4]);
                  if(i < Z-1) red = Parametri.Uzmi();
                  if(red[2] != 'G'){ printf("Nesto nedostaje!\n"); exit(1); }
                }
                break;
      case '"': i=3; while( red[i]!='"' ) i++;
                red[i] = 0;
                ucitaj_problem_stg(&red[3]);
                break;
      }
   }
   //ispisi_parametre();
}

void ucitaj_problem_stg(char *ime_dat){
   char *red;
   int i,j,redak_RP,brojac,br_Z;
   Text_file Zadatak(ime_dat,"r+");
   
   if( (red = Zadatak.Uzmi()) == NULL ){ printf("Greska u datoteci %s\n",ime_dat); }
   Z = broj(red);
   // RP = (int *)malloc(Z*(Z-1)*sizeof(int));
   // redak vise!!!
   RP = (int *)new int[Z*Z]; // bolje preko new nego preko malloc!!!
   for(redak_RP=0;redak_RP<Z;redak_RP++) for(i=0;i<Z;i++) RP[redak_RP*Z+i] = 0; // resetiraj vrijednosti
   P = broj(&red[6]);

   for(brojac=1;brojac<=Z;brojac++){
      if( (red = Zadatak.Uzmi()) == NULL ){ printf("Greska u datoteci %s\n",ime_dat); exit(1); }
      i = 0;
      redak_RP = broj(red);
      if( redak_RP != brojac ){ printf("Brojac zadatak je otkrio gresku u ulaznoj datoteci\n"); exit(1); }
      i += 6;
      T[redak_RP-1] = (float)atof(&red[i]);
      i += 6;
      br_Z = broj(&red[i]);
      for(j=0;j<br_Z;j++){
         i += 6;
         RP[ ( broj( &red[i] ) - 1 ) * Z + (redak_RP-1) ] = 1;
      }
   }
}

void ispisi_parametre(){ // za PROBLEM RASPOREDA
   int i,j;
   printf("broj zadataka Z = %d, broj procesora P = %d\n",Z,P);
   printf("broj iteracija I = %d, vjerojatnost mutacije PM = %d\n",MAX_GEN,PM);
   printf("velicina populacije V_POP = %d\nTRAJANJA ZADATAKA:\n",V_POP);
   for(i=0;i<Z;i++){
      printf("zadatak %d traje %f\n",i,T[i]);
   }
   printf("\nRELACIJA PRETHODJENJA\n");
   for(i=0;i<Z-1;i++){
      for(j=0;j<Z;j++) printf("%d",RP[i*Z+j]);
      printf("\n");
   }
   exit(1);
}

void ispisi_long(long l){
   for(int i=0;i<BR_B;i++) printf("%d", (l & (UL)1<<(BR_B-1-i) ) != 0 );
}

void vrsta(void){
   p = (POPULACIJA*)new POPULACIJA(V_POP); // inicijalizacija populacije p
   p->Zivite_i_mnozite_se();
   delete p; // destruktor populacije
}
