  /************************************/
 /* KROMOSOM.CPP - PROBLEM RASPOREDA */
/************************************/

#include "glava.h"

KROMOSOM::KROMOSOM(){
   int i, j; //Ognjen: dodao j
   z = Z; p = P;
   k = (int *)new int[(z+1)*p];
   if(k==NULL){printf("Nema memorije!\n"); exit(1); }
   for(i=0;i<p;i++) for(j=0;j<z;j++) k[i*z+j] = 0; // ne treba ako se koristi calloc ili new? //Ognjen: TREBA!!! (odkomentirao liniju)
   for(i=1;i<=z;i++) umetni(i,sluc(p)); // kromosom generiraj slucajno
}

//Ognjen: dodao copy konstruktor
KROMOSOM::KROMOSOM(const KROMOSOM &pr)
{
   int i, j;
   z = Z; p = P;
   //kreiraj novu tablicu
   k = (int *)new int[(z+1)*p];
   if(k==NULL){printf("Nema memorije!\n"); exit(1); }
   //skopiraj vrijednosti
   for(i=0;i<p;i++) for(j=0;j<z;j++) k[i*z+j] = pr.k[i*z+j];
   fx = pr.fx;
}

KROMOSOM::~KROMOSOM(){
   delete k;
}

void KROMOSOM::operator =(const KROMOSOM &pr){
   int i,j;
   for(i=0;i<p;i++) for(j=0;j<z;j++) k[i*z+j] = pr.k[i*z+j];
   fx = pr.fx;
}

void KROMOSOM::evaluiraj(){
   int i,j,q,pom[MAXP];
   static double TFT[MAXZ], FT[MAXP]; //Task Finishing Time i (proc) Finishing Time
   for(i=0;i<p;i++) FT[i] = pom[i] = 0;
   for(i=0;i<z;i++) TFT[i] = 0;
   for(j=0;j<z;j++){ // za svaki zadatak j koji se obavlja na i-tom procesoru radi:
      // trazi na kojem se procesoru obavlja (odredi i)
      i = gdje_je(j+1);
      // pronadjen je i-ti procesor koji obavlja j-ti zadatak
      TFT[j]=FT[i]+T[j]; // ovo se jos moze promijeniti zbog RP
                         // PRIVREMENO, tj. za sada je FT[i] = trenutak pocetka sada j-tog zadatka
      for(q=0;q<j;q++){  // za sve zadatke s manjim indeksom provjeri
         if(RP[q*z+j]){  //    da li moraju zavrsiti prije, ako moraju tada:
            if(i == gdje_je(q+1)) continue;
            if(TFT[q]>FT[i]){ // ako q-ti zadatak zavrsava poslije nego sto j-ti pocinje
               FT[i]=TFT[q];      // FT[i] je i dalje pocetak j-tog zadtka koji se dogadja sada malo kasnije
               TFT[j]=FT[i]+T[j]; // zavrsetak j-tog zadatka dogadja se od trenutka pocetka plus njegovo trajanje
            }
         }
      }
      FT[i]=TFT[j]; // ispravljamo ono PRIVREMENO
   }
   fx = FT[0]; //pretpostavimo da zadnji zavrsava 0-ti procesor
   // to treba i provjeriti i po potrebi promijeniti
   for(i=1;i<p;i++) if(fx<FT[i]) fx = FT[i];
   fx = -fx;
}

void KROMOSOM::ispisi(void){
/*   int i,j;
   for(i=0;i<p;i++){
      printf("%d: ",i);
      for(j=0;j<z;j++) printf("%2d ",k[i*z+j]);
      printf("\n");
   }
*/
   printf("%5d: ===   fx = %f   ===    BrJednakiRoditelji = %5d   ===\n",rbr_gen + 1,fx,BrJednakiRoditelji); //Ognjen: dodao "+ 1" kod rbr_gen da ispisuje iteracije pocevsi od 1 a ne od 0
   //Ognjen: gore dodao ispis brojaca jednakih roditelja
}

//Ognjen: dodao za potrebu grafickog prikaza rasporeda
/* ispisuje u datoteku slijedece:
       1. redak: Z(broj taskova) P(broj procesora)
	   zatim Z redaka, po jedan za svaki task:
	   INDEX+1. redak: INDEX  TRAJANJE  NA_KOJEM_PROCESORU  VRIJEME_POCETKA
	   INDEX - int
	   TRAJANJE - float
	   NA_KOJEM_PROCESORU - int
	   VRIJEME_POCETKA - double
*/  
void KROMOSOM::ispisi_detaljno(void)
{
	FILE *fout;
	double ST; //(Task) Start Time
	//koristim kod od KROMOSOM::evaluiraj()
	int i,j,q,pom[MAXP];
	static double TFT[MAXZ], FT[MAXP]; //Task Finishing Time i (proc) Finishing Time
	for(i=0;i<p;i++) FT[i] = pom[i] = 0;
	for(i=0;i<z;i++) TFT[i] = 0;
	for(j=0;j<z;j++){ // za svaki zadatak j koji se obavlja na i-tom procesoru radi:
	  // trazi na kojem se procesoru obavlja (odredi i)
	  i = gdje_je(j+1);
	  // pronadjen je i-ti procesor koji obavlja j-ti zadatak
	  TFT[j]=FT[i]+T[j]; // ovo se jos moze promijeniti zbog RP
						 // PRIVREMENO, tj. za sada je FT[i] = trenutak pocetka sada j-tog zadatka
	  for(q=0;q<j;q++){  // za sve zadatke s manjim indeksom provjeri
		 if(RP[q*z+j]){  //    da li moraju zavrsiti prije, ako moraju tada:
			if(i == gdje_je(q+1)) continue;
			if(TFT[q]>FT[i]){ // ako q-ti zadatak zavrsava poslije nego sto j-ti pocinje
			   FT[i]=TFT[q];      // FT[i] je i dalje pocetak j-tog zadtka koji se dogadja sada malo kasnije
			   TFT[j]=FT[i]+T[j]; // zavrsetak j-tog zadatka dogadja se od trenutka pocetka plus njegovo trajanje
			}
		 }
	  }
	  FT[i]=TFT[j]; // ispravljamo ono PRIVREMENO
	}
	//kraj koda od KROMOSOM::evaluiraj()
	fout = fopen(ime_izl_dat, "w");
	fprintf(fout, "%6d%6d\n", Z, P);
	for(j=0;j<z;j++)
	{
		ST = (double)TFT[j] - (double)T[j];
		fprintf(fout, "%6d%6.0f%6d%6.0f\n", j+1, T[j], gdje_je(j+1), ST);
	}
}

KROMOSOM KROMOSOM::operator +(KROMOSOM &q){
   int i,j,poz1,poz2,razlika;
   static KROMOSOM s;
   // resetiraj vrijednosti djetetu
   for(i=0;i<p;i++) for(j=0;j<z;j++) s.k[i*z+j] = 0;
   s.fx=0;

   razlika = 0;   // pretpostavimo da se roditelji ne razlikuju
   for(i=1;i<=z;i++){   // za svaki zadatak radi
      poz1 = gdje_je(i);
      poz2 = q.gdje_je(i);
      if( poz1 != poz2 ){   // ako nisu na istom mjestu
         if(sluc(1)) poz1=poz2;
         razlika++;
      }
      s.umetni(i,poz1);
   }
   if( !razlika ){   // ako su isti
      q <= PM;        //    mutiraj tatu
	  q.evaluiraj();  //Ognjen: treba ga i evaluirati!!!
	  BrJednakiRoditelji++;		//Ognjen: povecaj brojac dogadjaja jednakih roditelja
      for(i=0;i<p;i++) for(j=0;j<z;j++) s.k[i*z+j] = 0;  // sve izbrisi
      for(i=1;i<=z;i++) s.umetni(i,sluc(p)); // dijete generiraj slucajno
   }
   return s;
}

void KROMOSOM::operator <=(int pm){
   int i,rkamo,poz;
   for(i=1;i<=z;i++){ // svaki zadatak mutiraj s vjerojatnoscu pm
      if( sluc(1000) < (unsigned long)pm ){
         poz = gdje_je(i);
         do{ rkamo = sluc(p); } while( rkamo ==  poz);
         izbaci(i,poz);
         umetni(i,rkamo);
      }
   }
}

inline void KROMOSOM::umetni(int sto, int kamo){
   int i,j;
   i=0;
   while( k[kamo*z+i]!=0 && k[kamo*z+i]<sto ) i++; //nadji mjesto
   if( k[kamo*z+i] ){	// po potrebi pomakni da bi umetnuo
      for(j=z-1;j>i;j--) k[kamo*z+j] = k[kamo*z+j-1];
   }
   k[kamo*z+i] = sto;
}

inline void KROMOSOM::izbaci(int sto, int gdje){
   int i = -1;
   do{i++;}while( sto != k[gdje*z+i] );
   while( k[gdje*z+i] ) k[gdje*z+i] = k[gdje*z+(++i)]; // pomakni
}

inline int KROMOSOM::gdje_je(int sto){
   int i,j;
   for(i=0;i<p;i++){
      for(j=0;j<z;j++) if( k[i*z+j] == sto ) return i;
   }
   printf("Dogodila se neka gadna greska u %d iteraciji, jer nisam mogao naci zadatak %d!\n",rbr_gen,sto);
   ispisi();
   exit(1);
}
