     /*************************************************************/
    /* POPULACI.CPP - ovo ostaje nepromijenjeno neovisno o kojem */
   /*                 se problemu radi                          */
  /*                - ni o kojem GA se radi:                   */
 /*                              serijski GA / PGA            */
/*************************************************************/

#include "glava.h"

int NISP; // ucestalost ispisa, naj-bolji kromosom
long rbr_gen;
long BrJednakiRoditelji; //Ognjen: dodao za brojanje slucaja da su roditelji jednaki

POPULACIJA::POPULACIJA(int n){
   int i;
   VEL_POP=n;
   for(i=0;i<n;i++){ 
      a[i]=(KROMOSOM*)new KROMOSOM();
      a[i]->mbr = i;
      a[i]->evaluiraj();
   }
}

POPULACIJA::~POPULACIJA(void){
   for(int i=0;i<VEL_POP;i++) delete a[i]; 
}

void POPULACIJA::ispisi(void){
   for(int i=0;i<VEL_POP;i++){ printf("%3d:",i); a[i]->ispisi(); }
}

int POPULACIJA::najbolji(void){
   int i, max = 0;
   for(i=1;i<VEL_POP;i++) if( a[i]->fx > a[max]->fx ) max = i;
   return(max);
}

void POPULACIJA::TurnirGA(void){
   int mama,tata,dijete,pom;

   // ODABERI TROJICU, ali pazi da ne odaberes iste
   mama = sluc(VEL_POP);
   do tata = sluc(VEL_POP); while(tata==mama);
   do dijete = sluc(VEL_POP);   while( (dijete == mama) || (dijete == tata) );

   // KOJI JE OD ODABRANIH NAJSLABIJI? Pa, dijete!
   if( a[dijete]->fx > a[tata]->fx){ pom=dijete; dijete=tata; tata=pom; }
   if( a[dijete]->fx > a[mama]->fx){ pom=dijete; dijete=mama; mama=pom; }

   // REPRODUKCIJA = KRIANJE + MUTACIJA
   *a[dijete] = *a[mama] + *a[tata]; // KRIANJE
   *a[dijete] <= PM;                 // MUTACIJA

   // EVALUIRAJ I ISPII
   a[dijete]->evaluiraj();
   if( !((rbr_gen+1) %NISP) ) a[najbolji()]->ispisi();
}

// RADI SE O SERIJSKOM GA PA NEKE LINIJE KODA MORAM KOMENTIRATI
//void *Dretva(void *x){ 
//   for(rbr_gen=0;rbr_gen<MAX_GEN;rbr_gen++) p->TurnirGA();
//}

void POPULACIJA::Zivite_i_mnozite_se(void){
//   int i;
//   for(i=0;i<BR_DRETVI;i++)
//      if(thr_create(NULL,0,Dretva,NULL,THR_BOUND,NULL)){
//         cout << "Ne mogu kreirati dretvu" << "\n";
//         exit(1);
//      }
//   while( thr_join(0,NULL,NULL) == 0 );
	if ( (NISP > 10) && (NISP % 10 == 1))  //Ognjen: da ispise najboljeg u 0. iteraciji ako parametar NISP zadnju znamenku ima 1
   {
      rbr_gen=-1;
	  a[najbolji()]->ispisi();
	  NISP--; // oduzmi mu zadnju znamenku (npr. ako je 101 da ispise 0. i svaku 100-tu iteraciju)
   }

   BrJednakiRoditelji = 0; //Ognjen: za brojanje slucajeva jednakih roditelja, ispisuje se kod ispisa kromosoma

   for(rbr_gen=0;rbr_gen<MAX_GEN;rbr_gen++) p->TurnirGA();
   rbr_gen--; //Ognjen: da vrati rbr_gen na MAX_GEN-1, kako bi iduca naredba ispravno ispisala rbr_gen
   a[najbolji()]->ispisi();

   a[najbolji()]->ispisi_detaljno();//Ognjen: dodao za potrebu grafickog prikaza rasporeda
}
