  /************************************/
 /* KROMOSOM.CPP - PROBLEM RASPOREDA */
/************************************/

#include "glava.h"

KROMOSOM::KROMOSOM(){
   int i;
   z = Z; p = P;
   k = (int *)new int[(z+1)*p];
   if(k==NULL){printf("Nema memorije!\n"); exit(1); }
   //for(i=0;i<p;i++) for(j=0;j<z;j++) k[i*z+j] = 0; // ne treba ako se koristi calloc ili new?
   for(i=1;i<=z;i++) umetni(i,sluc(p)); // kromosom generiraj slucajno
}

KROMOSOM::~KROMOSOM(){
   delete k;
}

void KROMOSOM::operator =(const KROMOSOM &pr){
   int i,j;
   for(i=0;i<p;i++) for(j=0;j<z;j++) k[i*z+j] = pr.k[i*z+j];
   fx = pr.fx;
}

void KROMOSOM::evaluiraj(){
   int i,j,q,pom[MAXP];
   static double TFT[MAXZ], FT[MAXP]; //Task Finishing Time i (proc) Finishing Time
   for(i=0;i<p;i++) FT[i] = pom[i] = 0;
   for(i=0;i<z;i++) TFT[i] = 0;
   for(j=0;j<z;j++){ // za svaki zadatak j koji se obavlja na i-tom procesoru radi:
      // trazi na kojem se procesoru obavlja (odredi i)
      i = gdje_je(j+1);
      // pronadjen je i-ti procesor koji obavlja j-ti zadatak
      TFT[j]=FT[i]+T[j]; // ovo se jos moze promijeniti zbog RP
                         // PRIVREMENO, tj. za sada je FT[i] = trenutak pocetka sada j-tog zadatka
      for(q=0;q<j;q++){  // za sve zadatke s manjim indeksom provjeri
         if(RP[q*z+j]){  //    da li moraju zavrsiti prije, ako moraju tada:
            if(i == gdje_je(q+1)) continue;
            if(TFT[q]>FT[i]){ // ako q-ti zadatak zavrsava poslije nego sto j-ti pocinje
               FT[i]=TFT[q];      // FT[i] je i dalje pocetak j-tog zadtka koji se dogadja sada malo kasnije
               TFT[j]=FT[i]+T[j]; // zavrsetak j-tog zadatka dogadja se od trenutka pocetka plus njegovo trajanje
            }
         }
      }
      FT[i]=TFT[j]; // ispravljamo ono PRIVREMENO
   }
   fx = FT[0]; //pretpostavimo da zadnji zavrsava 0-ti procesor
   // to treba i provjeriti i po potrebi promijeniti
   for(i=1;i<p;i++) if(fx<FT[i]) fx = FT[i];
   fx = -fx;
}

void KROMOSOM::ispisi(void){
/*   int i,j;
   for(i=0;i<p;i++){
      printf("%d: ",i);
      for(j=0;j<z;j++) printf("%2d ",k[i*z+j]);
      printf("\n");
   }
*/
   printf("%5d: ===   fx = %f   ===\n",rbr_gen,fx);
}

KROMOSOM KROMOSOM::operator +(KROMOSOM &q){
   int i,j,poz1,poz2,razlika;
   static KROMOSOM s;
   // resetiraj vrijednosti djetetu
   for(i=0;i<p;i++) for(j=0;j<z;j++) s.k[i*z+j] = 0;
   s.fx=0;

   razlika = 0;   // pretpostavimo da se roditelji ne razlikuju
   for(i=1;i<=z;i++){   // za svaki zadatak radi
      poz1 = gdje_je(i);
      poz2 = q.gdje_je(i);
      if( poz1 != poz2 ){   // ako nisu na istom mjestu
         if(sluc(1)) poz1=poz2;
         razlika++;
      }
      s.umetni(i,poz1);
   }
   if( !razlika ){   // ako su isti
      q <= PM;        //    mutiraj tatu
      for(i=0;i<p;i++) for(j=0;j<z;j++) s.k[i*z+j] = 0;  // sve izbrisi
      for(i=1;i<=z;i++) s.umetni(i,sluc(p)); // dijete generiraj slucajno
   }
   return s;
}

void KROMOSOM::operator <=(int pm){
   int i,rkamo,poz;
   for(i=1;i<=z;i++){ // svaki zadatak mutiraj s vjerojatnoscu pm
      if( sluc(1000) < (unsigned long)pm ){
         poz = gdje_je(i);
         do{ rkamo = sluc(p); } while( rkamo ==  poz);
         izbaci(i,poz);
         umetni(i,rkamo);
      }
   }
}

void KROMOSOM::umetni(int sto, int kamo){
   int i,j;
   i=0;
   while( k[kamo*z+i]!=0 && k[kamo*z+i]<sto ) i++; //nadji mjesto
   if( k[kamo*z+i] ){	// po potrebi pomakni da bi umetnuo
      for(j=z-1;j>i;j--) k[kamo*z+j] = k[kamo*z+j-1];
   }
   k[kamo*z+i] = sto;
}

void KROMOSOM::izbaci(int sto, int gdje){
   int i = -1;
   do{i++;}while( sto != k[gdje*z+i] );
   while( k[gdje*z+i] ) k[gdje*z+i] = k[gdje*z+(++i)]; // pomakni
}

int KROMOSOM::gdje_je(int sto){
   int i,j;
   for(i=0;i<p;i++){
      for(j=0;j<z;j++) if( k[i*z+j] == sto ) return i;
   }
   printf("Dogodila se neka gadna greska u %d iteraciji, jer nisam mogao naci zadatak %d!\n",rbr_gen,sto);
   ispisi();
   exit(1);
}
